diff -BbruN freeswan-1.91.orig/klips/net/ipsec/pfkey_v2_parser.c freeswan-1.91/klips/net/ipsec/pfkey_v2_parser.c
--- freeswan-1.91.orig/klips/net/ipsec/pfkey_v2_parser.c	Fri Jun 15 00:57:02 2001
+++ freeswan-1.91/klips/net/ipsec/pfkey_v2_parser.c	Mon Jul  2 21:03:21 2001
@@ -1049,10 +1049,13 @@
 		unsigned int aks, eks;
 		
 		switch(tdbp->tdb_encalg) {
+# ifdef CONFIG_IPSEC_ENC_DES
+		case ESP_DES:
+# endif /* CONFIG_IPSEC_ENC_DES */
 # ifdef CONFIG_IPSEC_ENC_3DES
 		case ESP_3DES:
 # endif /* CONFIG_IPSEC_ENC_3DES */
-# if defined(CONFIG_IPSEC_ENC_3DES)
+# if defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES)
 			if((tdbp->tdb_iv = (caddr_t)
 			    kmalloc((tdbp->tdb_iv_size = EMT_ESPDES_IV_SZ), GFP_ATOMIC)) == NULL) {
 				SENDERR(ENOMEM);
@@ -1060,7 +1063,7 @@
 			get_random_bytes((void *)tdbp->tdb_iv, EMT_ESPDES_IV_SZ);
 			tdbp->tdb_iv_bits = tdbp->tdb_iv_size * 8;
 			break;
-# endif /* defined(CONFIG_IPSEC_ENC_3DES) */
+# endif /* defined(CONFIG_IPSEC_ENC_DES) || defined(CONFIG_IPSEC_ENC_3DES) */
 		case ESP_NONE:
 			break;
 		default:
@@ -1072,6 +1075,52 @@
 		}
 		
 		switch(tdbp->tdb_encalg) {
+#ifdef CONFIG_IPSEC_ENC_DES
+               case ESP_DES:
+                       if(tdbp->tdb_key_bits_e != (EMT_ESPDES_KEY_SZ * 8)) {
+                               KLIPS_PRINT(debug_pfkey,
+                                           "klips_debug:pfkey_tdb_init: "
+                                           "incorrect encryption key size: %d bits -- must be %d bits\n"/*octets (bytes)\n"*/,
+                                           tdbp->tdb_key_bits_e, EMT_ESPDES_KEY_SZ * 8);
+                               SENDERR(EINVAL);
+                       }
+                       
+                       /* save encryption key pointer */
+                       ekp = tdbp->tdb_key_e;
+                       eks = tdbp->tdb_key_e_size;
+                       
+                       if((tdbp->tdb_key_e = (caddr_t)
+                           kmalloc(sizeof(struct des_eks), GFP_ATOMIC)) == NULL) {
+                               tdbp->tdb_key_e = ekp;
+                               SENDERR(ENOMEM);
+                       }
+                       tdbp->tdb_key_e_size = sizeof(struct des_eks);
+
+#if 0 /* we don't really want to print these unless there are really big problems */
+                       KLIPS_PRINT(debug_pfkey,
+                                   "klips_debug:pfkey_tdb_init: des key 1 is 0x%08lx%08lx\n",
+                                   ntohl(*((__u32 *)ed->eme_key)),
+                                   ntohl(*((__u32 *)ed->eme_key + 1)));
+#endif
+                       error = des_set_key((caddr_t)ekp, 
+                                           (caddr_t)(tdbp->tdb_key_e));
+                       if (error == -1)
+                                       printk("klips_debug:pfkey_tdb_init: "
+                                              "parity error in des key\n");
+                               else if (error == -2)
+                                       printk("klips_debug:pfkey_tdb_init: "
+                                              "illegal weak des key\n");
+                               if (error) {
+                                       memset(ekp, 0, eks);
+                                       kfree(ekp);
+                                       SENDERR(EINVAL);
+                               }
+
+                       /* paranoid */
+                       memset(ekp, 0, eks);
+                       kfree(ekp);
+                       break;
+#endif /* CONFIG_IPSEC_ENC_DES */
 # ifdef CONFIG_IPSEC_ENC_3DES
 		case ESP_3DES:
 			if(tdbp->tdb_key_bits_e != (EMT_ESP3DES_KEY_SZ * 8)) {
@@ -3247,6 +3296,14 @@
 		/* auth_minbits; auth_maxbits; encrypt_minbits; encrypt_maxbits; */
 		/* reserved; soft_allocations; hard_allocations; soft_bytes; hard_bytes; */
 		/* soft_addtime; hard_addtime; soft_usetime; hard_usetime; */
+               { SADB_AALG_MD5HMAC,  SADB_EALG_DESCBC, SADB_SAFLAGS_PFS,
+                 128, 128, 56, 56,
+                 0, 0, 0, 0, 0,
+                 57600, 86400, 57600, 86400 },
+               { SADB_AALG_SHA1HMAC, SADB_EALG_DESCBC, SADB_SAFLAGS_PFS,
+                 160, 160, 56, 56,
+                 0, 0, 0, 0, 0,
+                 57600, 86400, 57600, 86400 },
 		{ SADB_AALG_MD5HMAC,  SADB_EALG_3DESCBC, SADB_SAFLAGS_PFS,
 		  128, 128, 168, 168,
 		  0, 0, 0, 0, 0,
diff -BbruN freeswan-1.91.orig/klips/net/ipsec/version.c freeswan-1.91/klips/net/ipsec/version.c
--- freeswan-1.91.orig/klips/net/ipsec/version.c	Wed May 30 09:02:20 2001
+++ freeswan-1.91/klips/net/ipsec/version.c	Tue Jul  3 04:03:17 2001
@@ -1,2 +1,2 @@
 /* silly pointless RCSID $Id: version.c,v 1.19 2001/05/30 13:02:20 henry Exp $ */
-static const char freeswan_version[] = "1.91";
+static const char freeswan_version[] = "FreeSWAN-1.91-pkix1";
diff -BbruN freeswan-1.91.orig/klips/utils/Makefile freeswan-1.91/klips/utils/Makefile
--- freeswan-1.91.orig/klips/utils/Makefile	Thu Jun 14 15:35:13 2001
+++ freeswan-1.91/klips/utils/Makefile	Mon Jul  2 21:05:30 2001
@@ -31,8 +31,8 @@
 CFLAGS+= -Wbad-function-cast 
 
 ALL=spi eroute spigrp tncfg klipsdebug
-BINDIR=/usr/local/lib/ipsec
-MANTREE=/usr/local/man
+BINDIR=/usr/lib/ipsec
+MANTREE=/usr/man
 MANDIR8=$(MANTREE)/man8
 MANDIR5=$(MANTREE)/man5
 FREESWANLIB=../../lib/libfreeswan.a
@@ -41,11 +41,11 @@
 all: $(ALL)
 
 install: $(ALL)
-	$(INSTALL) $(ALL) $(BINDIR)
+	$(INSTALL) $(ALL) $(PREFIX)/$(BINDIR)
 	for f in $(addsuffix .8, $(ALL)) ; do \
-		$(INSTALL) $$f $(MANDIR8)/ipsec_$$f || exit 1 ; done
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR8)/ipsec_$$f || exit 1 ; done
 	for f in $(addsuffix .5, $(ALL) version pf_key) ; do \
-		$(INSTALL) $$f $(MANDIR5)/ipsec_$$f || exit 1 ; done
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR5)/ipsec_$$f || exit 1 ; done
 
 spi: spi.o
 	$(CC) $(DFLAGS) -o $@ $? $(FREESWANLIB)
diff -BbruN freeswan-1.91.orig/klips/utils/version.c freeswan-1.91/klips/utils/version.c
--- freeswan-1.91.orig/klips/utils/version.c	Wed May 30 09:02:20 2001
+++ freeswan-1.91/klips/utils/version.c	Mon Jul  2 21:06:39 2001
@@ -1,2 +1,2 @@
 /* silly pointless RCSID $Id: version.c,v 1.19 2001/05/30 13:02:20 henry Exp $ */
-static const char freeswan_version[] = "1.91";
+static const char freeswan_version[] = "FreeSWAN-1.91-pkix1";
diff -BbruN freeswan-1.91.orig/lib/Makefile freeswan-1.91/lib/Makefile
--- freeswan-1.91.orig/lib/Makefile	Wed Oct 25 19:58:57 2000
+++ freeswan-1.91/lib/Makefile	Mon Jul  2 21:51:03 2001
@@ -60,8 +60,8 @@
 	mkdir -p $(MANDIR)
 	for f in $(MANS) ; \
 	do \
-		$(INSTALL) $$f $(MANDIR)/ipsec_$$f || exit 1 ; \
-		../utils/manlink $(MANDIR) ipsec_$$f ; \
+		$(INSTALL) $$f $(PREFIX)/$(MANDIR)/ipsec_$$f || exit 1 ; \
+		../utils/manlink $(PREFIX)/$(MANDIR) ipsec_$$f ; \
 	done
 
 $(LIB):	$(OBJS)
diff -BbruN freeswan-1.91.orig/libdes/Makefile freeswan-1.91/libdes/Makefile
--- freeswan-1.91.orig/libdes/Makefile	Tue Oct 10 22:12:45 2000
+++ freeswan-1.91/libdes/Makefile	Mon Jul  2 21:53:03 2001
@@ -59,10 +59,10 @@
 #DES_ENC=asm/dx86-sol.o	asm/yx86-sol.o	# solaris format x86 
 #DES_ENC=asm/dx86bsdi.o	asm/yx86basi.o	# bsdi format x86 
 
-LIBDIR=/usr/local/lib
-BINDIR=/usr/local/bin
-INCDIR=/usr/local/include
-MANDIR=/usr/local/man
+LIBDIR=/usr/lib
+BINDIR=/usr/bin
+INCDIR=/usr/include
+MANDIR=/usr/man
 MAN1=1
 MAN3=3
 SHELL=/bin/sh
diff -BbruN freeswan-1.91.orig/pluto/Makefile freeswan-1.91/pluto/Makefile
--- freeswan-1.91.orig/pluto/Makefile	Sat Jun 16 15:36:40 2001
+++ freeswan-1.91/pluto/Makefile	Tue Jul  3 01:52:08 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: Makefile,v 1.79 2001/06/16 19:36:40 dhr Exp $
+# RCSID $Id: Makefile,v 1.76 2001/03/13 09:22:01 dhr Exp $
 
 SHELL = /bin/sh
 
@@ -31,17 +31,32 @@
 FREESWANLIB=$(FREESWANLIBDIR)/libfreeswan.a
 LIBDESLITE=$(FREESWANLIBDIR)/libdes.a
 
+ifeq "$(USEOPENSSL)" "1"
+OPENSSLDEFS=-DOPENSSL
+
+OPENSSLOBJS=openssl.o xmap.o xmap_file.o xmap_dir.o xmap_db.o xmap_ldap.o \
+	x_sobj.o
+
+LDAPLIBS=-L$(LDAPROOT)/lib -lldap -llber -Wl,-rpath $(LDAPROOT)/lib
+LDAPDEFS=-DHAVE_LDAP
+
+DBROOT=/usr
+DBINCS=-I$(DBROOT)/include
+DBLIBS=-L$(DBROOT)/lib -ldb
+DBDEFS=-DHAVE_DB -DHAVE_DB185
+endif # USEOPENSSL = 1
+
 KLIPSD=../klips/net/ipsec
 
 INSTALL=install
 
 # -O on Linux makes gcc coredump when compiling sha1.c
 # -Wundef is nice but RHL5.2 compiler doesn't support it
-CFLAGS = -g -Wall -W -Wmissing-prototypes -Wpointer-arith -Wbad-function-cast \
-	-Wcast-qual -Wmissing-declarations -Wwrite-strings -Wstrict-prototypes
+CFLAGS = -g -Wall -Wmissing-prototypes -Wpointer-arith -Wbad-function-cast \
+	-Wcast-qual -Wmissing-declarations -Wwrite-strings
 
 # where to find klips headers and FreeS/WAN headers
-HDRDIRS = -I$(KLIPSD) $(FREESWANINCLS)
+HDRDIRS = -I$(KLIPSD) $(FREESWANINCLS) $(OPENSSLINCLS) $(LDAPINCS) $(DBINCS)
 
 # On non-LINUX systems, these one of these may be needed (see endian.h)
 # BYTE_ORDER = -DBIG_ENDIAN=4321 -DLITTLE_ENDIAN=1234 -DBYTE_ORDER=BIG_ENDIAN
@@ -76,22 +91,31 @@
 
 CPPFLAGS = $(HDRDIRS) $(BYTE_ORDER) \
 	-DPLUTO -DKLIPS -DDODGE_DH_MISSING_ZERO_BUG \
-	-DDEBUG -DGCC_LINT
+	-DDEBUG -DGCC_LINT $(OPENSSLDEFS) $(LDAPDEFS) $(DBDEFS)
 
 ALLFLAGS = $(CPPFLAGS) $(CFLAGS)
 
 # libefence is a free memory allocation debugger
 # Solaris 2 needs -lsocket -lnsl
-LIBSPLUTO = -lgmp -lresolv # -lefence
+LIBSPLUTO = -lgmp -lresolv $(OPENSSLLIBS) $(LDAPLIBS) $(DBLIBS)  # -lefence
 
 LDFLAGS =
 
 # Solaris needs -lsocket -lnsl
 LIBSWHACK =
 
+LIBSD2H   = $(OPENSSLLIBS) $(DBLIBS)
+
 BINNAMEPLUTO = pluto
 BINNAMEWHACK = whack
 
+# Comment this out if you don't have Berkeley DB available, which,
+# if you're running Linux is a bit strange...
+#ifeq ($(USEOPENSSL),1)
+ifeq "$(USEOPENSSL)" "1"
+BINNAMED2H   = dir2hash
+endif
+
 RM = /bin/rm
 RMFLAGS = -f
 
@@ -105,7 +129,7 @@
 
 DISTGCRYPT = \
 	gcryptfix.c gcryptfix.h \
-	dsa.c dsa.h \
+        g10_dsa.c g10_dsa.h \
 	elgamal.c elgamal.h \
 	primegen.c \
 	smallprime.c
@@ -142,23 +166,30 @@
 
 # start of support for DSS/DSA.  Not currently used.
 # OBJSGCRYPT =  gcryptfix.o dsa.o elgamal.o primegen.o smallprime.o
-OBJSGCRYPT =
+OBJSGCRYPT = gcryptfix.o g10_dsa.o elgamal.o primegen.o smallprime.o
 
 OBJSPLUTO = connections.o constants.o cookie.o crypto.o defs.o log.o \
 	state.o main.o server.o timer.o id.o ipsec_doi.o kernel.o \
 	kernel_comm.o demux.o packet.o preshared.o dnskey.o rnd.o spdb.o \
-	sha1.o md5.o $(OBJSGCRYPT) $(LIBDESLITE) $(FREESWANLIB)
+	sha1.o md5.o $(OBJSGCRYPT) $(LIBDESLITE) $(FREESWANLIB) \
+	$(OPENSSLOBJS) $(LIBGMP)
 
 OBJSWHACK = whack.o $(FREESWANLIB)
 
-all: $(BINNAMEPLUTO) $(BINNAMEWHACK)
+#ifeq ($(USEOPENSSL),1)
+ifeq "$(USEOPENSSL)" "1"
+OBJSD2H = dir2hash.o
+endif
+
+all: $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINNAMED2H)
 
 install: all
-	$(INSTALL) $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINDIR)
-	$(INSTALL) pluto.8 $(PMANDIR)/ipsec_pluto.8
-	../utils/manlink $(PMANDIR) ipsec_pluto.8
-	$(INSTALL) ipsec.secrets.5 $(FMANDIR)
-	../utils/manlink $(FMANDIR) ipsec.secrets.5
+	$(INSTALL) $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINNAMED2H) \
+		$(PREFIX)/$(BINDIR)
+	$(INSTALL) pluto.8 $(PREFIX)/$(PMANDIR)/ipsec_pluto.8
+	../utils/manlink $(PREFIX)/$(PMANDIR) ipsec_pluto.8
+	$(INSTALL) ipsec.secrets.5 $(PREFIX)/$(FMANDIR)
+	../utils/manlink $(PREFIX)/$(FMANDIR) ipsec.secrets.5
 
 $(BINNAMEPLUTO): $(OBJSPLUTO)
 	$(CC) -o $(BINNAMEPLUTO) $(LDFLAGS) $(OBJSPLUTO) $(LIBSPLUTO)
@@ -166,6 +197,9 @@
 $(BINNAMEWHACK): $(OBJSWHACK)
 	$(CC) -o $(BINNAMEWHACK) $(OBJSWHACK) $(LIBSWHACK)
 
+$(BINNAMED2H): $(OBJSD2H)
+	$(CC) -o $(BINNAMED2H) $(OBJSD2H) $(LIBSD2H)
+
 distlist:
 	@echo $(DIST)
 
@@ -185,8 +219,10 @@
 realclean: clean
 
 clean:
-	$(RM) $(RMFLAGS) $(OBJSPLUTO) *.core core *~ a.out ktrace.out
-	$(RM) $(RMFLAGS) $(BINNAMEPLUTO) $(OBJSWHACK) $(BINNAMEWHACK)
+	$(RM) $(RMFLAGS) $(OBJSPLUTO) $(OBJSD2H) \
+		*.core core *~ a.out ktrace.out
+	$(RM) $(RMFLAGS) $(BINNAMEPLUTO) $(OBJSWHACK) $(BINNAMEWHACK) \
+		$(BINNAMED2H)
 
 .c.o:
 	$(CC) $(COPTS) $(ALLFLAGS) -c $<
@@ -221,9 +258,6 @@
 defs.o: defs.c
 demux.o: demux.c
 dnskey.o: dnskey.c
-dsa.o: dsa.c
-elgamal.o: elgamal.c
-gcryptfix.o: gcryptfix.c
 id.o: id.c
 ipsec_doi.o: ipsec_doi.c
 kernel.o: kernel.c
@@ -233,11 +267,9 @@
 md5.o: md5.c
 packet.o: packet.c
 preshared.o: preshared.c
-primegen.o: primegen.c
 rnd.o: rnd.c
 server.o: server.c
 sha1.o: sha1.c
-smallprime.o: smallprime.c
 spdb.o: spdb.c
 state.o: state.c
 timer.o: timer.c
@@ -302,23 +334,6 @@
 dnskey.o: dnskey.h
 dnskey.o: packet.h
 dnskey.o: timer.h
-dsa.o: constants.h
-dsa.o: defs.h
-dsa.o: log.h
-dsa.o: rnd.h
-dsa.o: gcryptfix.h
-dsa.o: dsa.h
-elgamal.o: constants.h
-elgamal.o: defs.h
-elgamal.o: log.h
-elgamal.o: rnd.h
-elgamal.o: gcryptfix.h
-elgamal.o: elgamal.h
-gcryptfix.o: constants.h
-gcryptfix.o: defs.h
-gcryptfix.o: log.h
-gcryptfix.o: rnd.h
-gcryptfix.o: gcryptfix.h
 id.o: constants.h
 id.o: defs.h
 id.o: id.h
@@ -351,7 +366,6 @@
 kernel.o: id.h
 kernel.o: connections.h
 kernel.o: state.h
-kernel.o: timer.h
 kernel.o: kernel.h
 kernel.o: log.h
 kernel.o: server.h
@@ -410,11 +424,6 @@
 preshared.o: dnskey.h
 preshared.o: log.h
 preshared.o: whack.h
-primegen.o: constants.h
-primegen.o: defs.h
-primegen.o: log.h
-primegen.o: rnd.h
-primegen.o: gcryptfix.h
 rnd.o: sha1.h
 rnd.o: constants.h
 rnd.o: defs.h
@@ -436,9 +445,6 @@
 server.o: whack.h
 sha1.o: sha1.h
 sha1.o: endian.h
-smallprime.o: constants.h
-smallprime.o: defs.h
-smallprime.o: gcryptfix.h
 spdb.o: constants.h
 spdb.o: defs.h
 spdb.o: id.h
@@ -474,7 +480,6 @@
 timer.o: packet.h
 timer.o: demux.h
 timer.o: ipsec_doi.h
-timer.o: kernel.h
 timer.o: server.h
 timer.o: log.h
 timer.o: rnd.h
diff -BbruN freeswan-1.91.orig/pluto/connections.c freeswan-1.91/pluto/connections.c
--- freeswan-1.91.orig/pluto/connections.c	Fri Jun 15 17:30:44 2001
+++ freeswan-1.91/pluto/connections.c	Tue Jul  3 01:56:45 2001
@@ -43,6 +43,10 @@
 #include "dnskey.h"	/* needs preshared.h */
 #include "whack.h"
 
+#ifdef OPENSSL
+#include "openssl.h"
+#include "xmap.h"
+#endif
 static void flush_pending_by_connection(struct connection *c);	/* forward */
 
 static struct connection *connections = NULL;
@@ -280,6 +284,20 @@
     }
     release_connection(c);	/* won't delete c */
 
+#ifdef OPENSSL
+    if (c->cert != NULL) X509_free((X509 *)(c->cert));
+    if (c->key != NULL) EVP_PKEY_free((EVP_PKEY *)(c->key));
+    if (c->lu != NULL) sk_XMAP_pop_free(c->lu, XMAP_free);
+    {
+      int i;
+
+      for (i=0; i<MAX_OTHER; i++)
+       if (c->other[i].cert != NULL) {
+         X509_free((X509 *)(c->other[i].cert));
+        }
+    }
+#endif
+
     /* find and delete c from connections list */
     list_rm(struct connection, ac_next, c, connections);
     cur_connection = old_cur_connection;
@@ -540,12 +558,61 @@
 static void
 unshare_connection_strings(struct connection *c)
 {
+#ifdef OPENSSL
+    void *tempcert, *tempkey;
+    STACK_OF(XMAP) *templu;
+#endif
     c->name = clone_str(c->name, "connection name");
 
     unshare_id_content(&c->this.id);
     c->this.updown = clone_str(c->this.updown, "updown");
     unshare_id_content(&c->that.id);
     c->that.updown = clone_str(c->that.updown, "updown");
+
+#ifdef OPENSSL
+    {
+      int i;
+
+      for (i=0; i<MAX_OTHER; i++)
+        if (c->other[i].cert) {
+          tempcert = c->other[i].cert;
+          c->other[i].cert = X509_dup(tempcert);
+        }
+    }
+
+
+    if (c->cert) {
+      tempcert = c->cert;
+      c->cert = X509_dup(tempcert);
+    }
+/* ******** HOW to use EVP_PKEY *************
+ * #define RSAPrivateKey_dup(rsa) (RSA *)ASN1_dup((int (*)())i2d_RSAPrivateKey,
+ *                (char *(*)())d2i_RSAPrivateKey,(char *)rsa)
+ * /usr/include/openssl/evp.h:621:RSA *  EVP_PKEY_get1_RSA(EVP_PKEY *pkey);
+ *
+ * DEFS:
+ * /usr/include/openssl/evp.h:637:EVP_PKEY *  d2i_PrivateKey(int type,
+ *               EVP_PKEY **a, unsigned char **pp,
+ * /usr/include/openssl/evp.h:641:int  i2d_PrivateKey(EVP_PKEY *a,
+ *               unsigned char **pp);
+ * X509 dup macro:
+ * #define X509_dup(x509) (X509 *)ASN1_dup((int (*)())i2d_X509, \
+ *                 (char *(*)())d2i_X509,(char *)x509)
+ * NEW MACRO:
+ * #define EVP_PKEY_dup(pkey) \
+ *   (EVP_PKEY *)ASN1_dup((int (*)())i2d_PrivateKey, \
+ *   (char *(*)())d2i_AutoPrivateKey,(char *)pkey)
+ */
+
+    if (c->key) {
+      tempkey = c->key;
+      c->key = EVP_PKEY_dup(tempkey);
+    }
+    if (c->lu) {
+      templu = c->lu;
+      c->lu = clone_sk_XMAP(templu);
+    }
+#endif
 }
 
 static void
@@ -615,7 +682,11 @@
 
 	    for (; c != NULL; c = c->hp_next)
 	    {
+#ifndef OPENSSL
 		if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_RSASIG))
+#else
+		if ((c->policy ^ wm->policy) & (POLICY_PSK | POLICY_OPENSSL))
+#endif
 		{
 		    loglog(RC_CLASH
 			, "authentication method disagrees with \"%s\", which is also for an unspecified peer"
@@ -631,6 +702,8 @@
 void
 add_connection(const struct whack_message *wm)
 {
+    bool success = TRUE;
+
     if (con_by_name(wm->name, FALSE) != NULL)
     {
 	loglog(RC_DUPNAME, "attempt to redefine connection \"%s\"", wm->name);
@@ -655,6 +728,15 @@
 	c->sa_rekey_fuzz = wm->sa_rekey_fuzz;
 	c->sa_keying_tries = wm->sa_keying_tries;
 
+	c->block_cypher = wm->block_cypher;
+
+#ifdef OPENSSL
+	c->this.id.key_id.len = 0;
+	c->that.id.key_id.len = 0;
+	c->this.id.der_asn1_dn.len = 0;
+	c->that.id.der_asn1_dn.len = 0;
+#endif
+
 	c->addr_family = wm->addr_family;
 	c->tunnel_addr_family = wm->tunnel_addr_family;
 
@@ -673,6 +755,43 @@
 	    c->that = t;
 	}
 
+#ifdef OPENSSL
+	{
+	    int i;
+
+	    for(i=0; i<MAX_OTHER; i++) {
+	      c->other[i].cert = NULL;
+	      c->other[i].type = 0;
+	    }
+	}
+	c->cert_options = parse_options(wm->whack_certopts);
+
+	/* c->cert_options can tell us if we have to deal with
+	 * X509 certs from now on. See function "use_openssl"
+	 */
+	if (c->cert_options != 0) {
+	  load_cert_and_key(wm->whack_certfile, wm->whack_keyfile,
+	    (X509 **)&(c->cert), (EVP_PKEY **)&(c->key), c->name);
+
+	  if ((c->cert == NULL) || (c->key == NULL)) {
+	    success = FALSE;
+	  }
+
+#if 0 /* to be removed? */
+	  /* ID_DER_ASN1_DN cannot be done with path=db or path=dir */
+	  if (! check_idtype_and_path(c, wm->whack_certpath)) {
+	    success = FALSE;
+	  }
+#endif
+
+          if (! make_lookups((STACK_OF(XMAP) **)(&(c->lu)),
+            wm->whack_certpath) ) {
+            success = FALSE;
+          }
+          strncpy(c->path, wm->whack_certpath, PATH_NAME_LIMIT);
+	}
+#endif
+
 	/* set internal fields */
 	c->ac_next = connections;
 	connections = c;
@@ -697,7 +816,8 @@
 
 	possibly_some_oppo = TRUE;	/* could be more careful about this */
 
-	/* log all about this connection */
+	/* log all about this connection, if successful */
+	if (success) {
 	log("added connection description \"%s\"", c->name);
 	DBG(DBG_CONTROL,
 	    char lhs[SUBNETTOT_BUF + ADDRTOT_BUF + IDTOA_BUF + ADDRTOT_BUF];
@@ -730,6 +850,15 @@
 		, (unsigned long) c->sa_keying_tries
 		, bitnamesof(sa_policy_bit_names, c->policy));
 	);
+	} else {
+	  loglog(RC_LOG_SERIOUS,
+	    "Adding connection description \"%s\" failed.",
+	    c->name);
+	  loglog(RC_LOG_SERIOUS,
+	    "Deleting connection description \"%s\".",
+	    c->name);
+	  delete_connection(c);
+	}
     }
 }
 
@@ -1057,6 +1186,17 @@
 	{
 	    /* what should we do on failure? */
 	    (void) assign_hold(c, our_client, peer_client);
+
+	    switch (c->routing){
+	    case RT_UNROUTED:
+	        c->routing = RT_UNROUTED_HOLD;
+	        break;
+	    case RT_ROUTED_PROSPECTIVE:
+	        c->routing = RT_ROUTED_HOLD;
+	        break;
+	    default:
+	        passert(FALSE);
+	    }
 	}
 	ipsecdoi_initiate(whackfd, c, c->policy, 1);
 	whackfd = NULL_FD;	/* protect from close */
@@ -1425,7 +1565,13 @@
 	break;
 
     case OAKLEY_RSA_SIG:
+#ifndef OPENSSL
 	auth_policy = POLICY_RSASIG;
+#else
+   case OAKLEY_RSA_ENC:
+   case OAKLEY_RSA_ENC_REV:
+	auth_policy = POLICY_OPENSSL;
+#endif
 	if (initiator)
 	{
 	    /* at this point, we've committed to our RSA private key:
@@ -1436,7 +1582,14 @@
 		return NULL;	/* cannot determine my RSA private key! */
 	}
 	break;
-
+#ifdef OPENSSL
+    case OAKLEY_DSS_SIG:
+    case OAKLEY_ELGAMAL_ENC:
+    case OAKLEY_ELGAMAL_ENC_REV:
+	auth_policy = POLICY_OPENSSL;
+	/* Not implemented yet */
+	break;
+#endif
     default:
 	passert(FALSE);
     }
@@ -1461,6 +1614,27 @@
 	{
 	    bool exact = same_id(peer_id, &d->that.id);	/* exact peer ID match? */
 
+#ifdef OPENSSL
+           /* fetch d's other cert, when applicable. */
+             if (auth_policy == POLICY_OPENSSL) {
+               bool r;
+               switch(auth) {
+                 case OAKLEY_RSA_SIG:
+                 case OAKLEY_RSA_ENC:
+                 case OAKLEY_RSA_ENC_REV:
+                   r = have_othercert(d, EVP_PKEY_RSA);
+                   break;
+
+                  case OAKLEY_DSS_SIG:
+                 case OAKLEY_ELGAMAL_ENC:
+                 case OAKLEY_ELGAMAL_ENC_REV:
+                   r = have_othercert(d, EVP_PKEY_DSA);
+                   break;
+               default:
+                   passert(FALSE);
+               } /* END switch */
+             }
+#endif
 	    /* check if peer_id matches, exactly or after instantiation */
 	    if (!exact && !(rw && d->that.id.kind == ID_NONE))
 		continue;
@@ -1492,6 +1666,10 @@
 		break;
 
 	    case OAKLEY_RSA_SIG:
+#ifdef OPENSSL
+           case OAKLEY_RSA_ENC:
+           case OAKLEY_RSA_ENC_REV:
+#endif
 		/* We must at least be able to find our private key.
 		 * If we initiated, it must match the one we
 		 * used in the SIG_I payload that we sent previously.
diff -BbruN freeswan-1.91.orig/pluto/connections.h freeswan-1.91/pluto/connections.h
--- freeswan-1.91.orig/pluto/connections.h	Mon May 28 15:18:17 2001
+++ freeswan-1.91/pluto/connections.h	Tue Jul  3 01:56:59 2001
@@ -14,6 +14,10 @@
  * RCSID $Id: connections.h,v 1.54 2001/05/28 19:18:17 dhr Exp $
  */
 
+#ifdef OPENSSL
+#include "openssl_defs.h"
+#endif
+
 /* There are two kinds of connections:
  * - ISAKMP connections, between hosts (for IKE communication)
  * - IPsec connections, between clients (for secure IP communication)
@@ -87,6 +91,13 @@
  * is a stat that uses it.
  */
 
+#ifdef OPENSSL
+struct other_st {
+  u_int32_t type; /* type of certificate in 'cert': EVP_PKEY_RSA or EVP_PKEY_DSA */
+  void *cert;
+};
+#endif
+
 struct end {
     struct id id;
     ip_address
@@ -101,6 +112,20 @@
 
 struct connection {
     char *name;
+#ifdef OPENSSL
+    /* The declaration of these as void is truly horrific - they 
+     * should be X509 and EVP_PKEY pointers. Unfortunately, if this
+     * is declared, the MD5 header files from OpenSSL conflict with those
+     * in the KLIPS source. Hence we cast these pointers to the right
+     * type at the time of use. It's disgusting, but I can't think of
+     * another way -- ND 
+     */
+    void *cert, *key, *lu;
+    struct other_st other[MAX_OTHER];
+    u_char path[PATH_NAME_LIMIT];
+    u_int32_t cert_options;
+#endif
+    lset_t block_cypher;
     lset_t policy;
     time_t sa_ike_life_seconds;
     time_t sa_ipsec_life_seconds;
diff -BbruN freeswan-1.91.orig/pluto/constants.c freeswan-1.91/pluto/constants.c
--- freeswan-1.91.orig/pluto/constants.c	Tue May 29 14:39:56 2001
+++ freeswan-1.91/pluto/constants.c	Tue Jul  3 02:02:30 2001
@@ -311,13 +312,38 @@
 enum_names ident_names =
     { ID_IPV4_ADDR, ID_KEY_ID, ident_name, NULL };
 
+#ifdef OPENSSL
+/* Certificate type values */
+static const char *const cert_name[] = {
+       "CERT_TYPE_NONE",
+       "CERT_TYPE_PKCS7",
+       "CERT_TYPE_PGP",
+       "CERT_TYPE_DNSKEY",
+       "CERT_TYPE_X509_SIG",
+       "CERT_TYPE_X509_KEX",
+       "CERT_TYPE_KERBEROS",
+       "CERT_TYPE_CRL",
+       "CERT_TYPE_ARL",
+       "CERT_TYPE_SPKI",
+       "CERT_TYPE_X509_ATTR",
+    };
+
+enum_names cert_names =
+    { CERT_TYPE_NONE, CERT_TYPE_X509_ATTR, cert_name, NULL };
+#endif
+
+
 /* Goal BITs for establishing an SA
  * Note: we drop the POLICY_ prefix so that logs are more concise.
  */
 
 const char *const sa_policy_bit_names[] = {
 	"PSK",
+#ifndef OPENSSL
 	"RSASIG",
+#else
+	"OPENSSL",
+#endif
 	"ENCRYPT",
 	"AUTHENTICATE",
 	"COMPRESS",
@@ -770,6 +796,26 @@
     return p;
 }
 
+void init_constants(void)
+{
+    err_t ugh;
+
+    ugh = anyaddr(AF_INET, &ipv4_any);
+    passert(ugh == NULL);
+    ugh = anyaddr(AF_INET, &ipv6_any);
+    passert(ugh == NULL);
+
+    ugh = rangetosubnet(&ipv4_any, &ipv4_any, &ipv4_wildcard);
+    passert(ugh == NULL);
+    ugh = rangetosubnet(&ipv6_any, &ipv6_any, &ipv6_wildcard);
+    passert(ugh == NULL);
+
+    ugh = initsubnet(&ipv4_any, 0, '0', &ipv4_all);
+    passert(ugh == NULL);
+    ugh = initsubnet(&ipv6_any, 0, '0', &ipv6_all);
+    passert(ugh == NULL);
+}
+
 /* construct a string to name the bits on in a set
  * Result may be in STATIC buffer!
  */
@@ -864,24 +910,4 @@
 	p = buf;
     }
     return p;
-}
-
-void init_constants(void)
-{
-    err_t ugh;
-
-    ugh = anyaddr(AF_INET, &ipv4_any);
-    passert(ugh == NULL);
-    ugh = anyaddr(AF_INET, &ipv6_any);
-    passert(ugh == NULL);
-
-    ugh = rangetosubnet(&ipv4_any, &ipv4_any, &ipv4_wildcard);
-    passert(ugh == NULL);
-    ugh = rangetosubnet(&ipv6_any, &ipv6_any, &ipv6_wildcard);
-    passert(ugh == NULL);
-
-    ugh = initsubnet(&ipv4_any, 0, '0', &ipv4_all);
-    passert(ugh == NULL);
-    ugh = initsubnet(&ipv6_any, 0, '0', &ipv6_all);
-    passert(ugh == NULL);
 }
diff -BbruN freeswan-1.91.orig/pluto/constants.h freeswan-1.91/pluto/constants.h
--- freeswan-1.91.orig/pluto/constants.h	Tue May 29 14:39:56 2001
+++ freeswan-1.91/pluto/constants.h	Tue Jul  3 02:02:31 2001
@@ -509,6 +509,30 @@
 #define ID_DER_ASN1_GN              10
 #define ID_KEY_ID                   11
 
+#ifdef OPENSSL
+#define CERT_OPTION_SEND           0x01
+#define CERT_OPTION_PKCS7          0x02
+#define CERT_OPTION_PK             0x04
+#define CERT_OPTION_REV            0x08
+#define CERT_OPTION_STRICT         0x10
+#define CERT_OPTION_DSS_SHA        0x20
+#define CERT_OPTION_DSS_ALT        0x40
+
+extern enum_names cert_names;
+
+#define CERT_TYPE_NONE              0
+#define CERT_TYPE_PKCS7             1
+#define CERT_TYPE_PGP               2
+#define CERT_TYPE_DNSKEY            3
+#define CERT_TYPE_X509_SIG          4
+#define CERT_TYPE_X509_KEX          5
+#define CERT_TYPE_KERBEROS          6
+#define CERT_TYPE_CRL               7
+#define CERT_TYPE_ARL               8
+#define CERT_TYPE_SPKI              9
+#define CERT_TYPE_X509_ATTR        10
+#endif
+
 /* Policies for establishing an SA
  *
  * These are used to specify attributes (eg. encryption) and techniques
@@ -519,10 +543,18 @@
 
 /* ISAKMP auth techniques */
 #define POLICY_PSK           LELEM(0)
+#ifndef OPENSSL
 #define POLICY_RSASIG        LELEM(1)
+#else
+#define POLICY_OPENSSL        LELEM(1)
+#endif
 
 #define POLICY_ISAKMP_SHIFT	0	/* log2(POLICY_PSK) */
+#ifndef OPENSSL
 #define POLICY_ID_AUTH_MASK	LRANGES(POLICY_PSK, POLICY_RSASIG)
+#else
+#define POLICY_ID_AUTH_MASK    LRANGES(POLICY_PSK, POLICY_OPENSSL)
+#endif
 #define POLICY_ISAKMP_MASK	POLICY_ID_AUTH_MASK	/* all so far */
 
 /* Quick Mode (IPSEC) attributes */
@@ -625,6 +657,12 @@
 
 #define SA_LIFE_DURATION_K_DEFAULT  0xFFFFFFFFlu
 
+/* DES support */
+#define ALL_BLOCK_CYPHER 1
+#define DES_BLOCK_CYPHER 2
+#define DES3_BLOCK_CYPHER 3
+#define FORCE_ENCRYPT_CYPHER_DEFAULT ALL_BLOCK_CYPHER
+
 /* Encapsulation Mode attribute */
 
 extern enum_names enc_mode_names;
diff -BbruN freeswan-1.91.orig/pluto/crypto.h freeswan-1.91/pluto/crypto.h
--- freeswan-1.91.orig/pluto/crypto.h	Sun Dec 12 19:40:50 1999
+++ freeswan-1.91/pluto/crypto.h	Tue Jul  3 02:04:35 2001
@@ -56,7 +56,11 @@
 /* unification of cryptographic hashing mechanisms */
 
 union hash_ctx {
+#ifndef OPENSSL
 	MD5_CTX ctx_md5;
+#else
+	PLUTO_MD5_CTX ctx_md5;
+#endif
 	SHA1_CTX ctx_sha1;
     };
 
diff -BbruN freeswan-1.91.orig/pluto/defs.c freeswan-1.91/pluto/defs.c
--- freeswan-1.91.orig/pluto/defs.c	Tue Mar 13 04:22:03 2001
+++ freeswan-1.91/pluto/defs.c	Tue Jul  3 02:05:03 2001
@@ -24,6 +24,8 @@
 #include "constants.h"
 #include "defs.h"
 #include "log.h"
+#include "id.h"
+#include "connections.h" /* needs id.h */
 #include "whack.h"	/* for RC_LOG_SERIOUS */
 
 const chunk_t empty_chunk = { NULL, 0 };
diff -BbruN freeswan-1.91.orig/pluto/defs.h freeswan-1.91/pluto/defs.h
--- freeswan-1.91.orig/pluto/defs.h	Tue May  8 01:37:21 2001
+++ freeswan-1.91/pluto/defs.h	Tue Jul  3 02:05:03 2001
@@ -59,6 +59,19 @@
 #define pfreeany(p) { if ((p) != NULL) pfree(p); }
 #define replace(p, q) { pfreeany(p); (p) = (q); }
 
+#ifdef OPENSSL
+#include <des.h>
+
+typedef union _keysched_u {
+  struct _des3_ks { des_key_schedule ks[3]; } des3_ks;
+  des_key_schedule des_ks;
+
+#ifdef NOTYET
+  /* Other ciphers, eg CAST, RC5, etc... */
+#endif
+
+} keysched;
+#endif
 
 /* chunk is a simple pointer-and-size abstraction */
 
@@ -108,3 +121,31 @@
 
 /* pad_up(n, m) is the amount to add to n to make it a multiple of m */
 #define pad_up(n, m) (((m) - 1) - (((n) + (m) - 1) % (m)))
+
+/* writemem_short adds support to write to unaligned memory (arm). */
+#ifdef __arm__
+#define writemem_u_int16_t(addr, offset, n) do {\
+  u_int16_t temp16 = htons((n)); \
+  (addr)[(offset)] = temp16 & 0xff; \
+  (addr)[(offset)+1] = temp16 >> 8; \
+} while (0)
+#else
+#define writemem_u_int16_t(addr, offset, n) do {\
+  *((u_int16_t *)(&((addr)[(offset)]))) = htons((n)); \
+} while (0)
+#endif
+
+/* readmem_short adds support to read from unaligned memory (arm). */
+#ifdef __arm__
+#define readmem_u_int16_t(addr, offset, var) do {\
+  u_int16_t temp16 = 0; \
+  temp16 += *((u_int8_t *)(&((addr)[(offset)]))) << 8; \
+  temp16 += *((u_int8_t *)(&((addr)[(offset)+1]))); \
+  (var) = temp16; \
+} while (0)
+#else
+#define readmem_u_int16_t(addr, offset, var) do {\
+  u_int16_t temp16 = ntohs(*((u_int16_t *)(&((addr)[(offset)])))); \
+  (var) = temp16; \
+} while (0)
+#endif
